import { system, world } from "@minecraft/server";

const recipes = [
    {
        output: "bbq_ribs",
        ingredients: [
            { item: "ww_dx:raw_pork_ribs", count: 1 },
            { item: "ww_dx:bbq_sauce", count: 1 },
        ],
    },
    {
        output: "burgers",
        ingredients: [
            { item: "ww_dx:raw_ground_beef", count: 1 },
            { item: "ww_dx:buns", count: 1 },
            { item: "ww_dx:lettuce", count: 1 },
            { item: "ww_dx:tomato", count: 1 },
            { item: "ww_dx:cheese", count: 1 },
        ],
    },
    {
        output: "chicken_kebab",
        ingredients: [
            { item: "minecraft:chicken", count: 1 },
            { item: "ww_dx:pepper", count: 1 },
            { item: "ww_dx:onion", count: 1 },
            { item: "minecraft:stick", count: 1 },
        ],
    },
    {
        output: "grilled_chicken_sandwich",
        ingredients: [
            { item: "minecraft:chicken", count: 1 },
            { item: "ww_dx:buns", count: 1 },
            { item: "ww_dx:lettuce", count: 1 },
            { item: "ww_dx:tomato", count: 1 },
            { item: "ww_dx:cheese", count: 1 },
        ],
    },
    {
        output: "hot_dog",
        ingredients: [
            { item: "ww_dx:buns", count: 1 },
            { item: "ww_dx:sausage", count: 1 },
        ],
    },
    {
        output: "roasted_corn",
        ingredients: [
            { item: "ww_dx:corn_on_cob", count: 1 },
            { item: "ww_dx:salt", count: 1 },
            { item: "ww_dx:butter", count: 1 },
        ],
    },
    {
        output: "roasted_veggies",
        ingredients: [
            { item: "ww_dx:zucchini", count: 1 },
            { item: "ww_dx:eggplant", count: 1 },
            { item: "ww_dx:olive_oil", count: 1 },
        ],
    },
];



const grill = new Map(); 


function processGrillInventory(entity) {
    const id = entity.id;


    if (grill.get(id)?.isProcessing) {

        return;
    }

    const inventoryComponent = entity.getComponent("minecraft:inventory");

    if (!inventoryComponent || !inventoryComponent.container) {

        return;
    }

    const inventory = inventoryComponent.container;

    for (const recipe of recipes) {
      
        let matches = true;

        const ingredientsMap = new Map(
            recipe.ingredients.map((ingredient) => [ingredient.item, ingredient.count])
        );

        for (let i = 0; i < inventory.size; i++) {
            const item = inventory.getItem(i);
            if (item) {
                if (ingredientsMap.has(item.typeId)) {
                    const remainingCount = ingredientsMap.get(item.typeId) - item.amount;
                    if (remainingCount <= 0) {
                        ingredientsMap.delete(item.typeId);
                    } else {
                        ingredientsMap.set(item.typeId, remainingCount);
                    }
                } else {
                 
                    matches = false;
                    break;
                }
            }
        }

        if (matches && ingredientsMap.size === 0) {
            entity.runCommandAsync("summon ww_dx:processing_particle ~ ~1 ~")

          
            for (const ingredient of recipe.ingredients) {
                let remainingToRemove = ingredient.count;

                for (let i = 0; i < inventory.size; i++) {
                    const item = inventory.getItem(i);
                    if (item && item.typeId === ingredient.item) {
                        if (item.amount > remainingToRemove) {
                            item.amount -= remainingToRemove;
                            inventory.setItem(i, item);
                            break;
                        } else {
                            remainingToRemove -= item.amount;
                            inventory.setItem(i, undefined);
                        }
                    }
                }
            }


          
            grill.set(id, { isProcessing: true });
            system.runTimeout(() => {
                if (!entity.isValid()) return;
                const { x, y, z } = entity.location;
              
                entity.runCommandAsync(`loot spawn ${x} ${y + 1} ${z} loot ${recipe.output}`);
                entity.runCommandAsync("event entity @e[type=ww_dx:processing_particle,r=1] ww_dx:despawn")
                entity.runCommandAsync("playsound ww_dx:finish_cooking @a[r=5]")
                
                grill.set(id, { isProcessing: false });
            }, 200);

            return;
        } else {
          
        }
    }


}

let worldInitialize = false;
world.afterEvents.playerSpawn.subscribe((event) => {
    worldInitialize = true;

})
function checkGrill() {
    if(!worldInitialize)return;
    const currentDimension = world.getDimension(world.getPlayers()[0].dimension.id);

    for (const entity of currentDimension.getEntities()) {
        if (entity.typeId === "ww_dx:grill") {
            if (!grill.has(entity.id)) {
                grill.set(entity.id, { isProcessing: false });

            }

            processGrillInventory(entity);
        }
    }
}


system.runInterval(() => {
    checkGrill();
}, 20); 
